public inbox for network@lists.ipfire.org
 help / color / mirror / Atom feed
From: Jonatan Schlag <jonatan.schlag@ipfire.org>
To: network@lists.ipfire.org
Subject: [network] [PATCH 4/4] pppoe-server: improve input validation
Date: Sat, 03 Jun 2017 13:25:10 +0200	[thread overview]
Message-ID: <1496489110-10134-4-git-send-email-jonatan.schlag@ipfire.org> (raw)
In-Reply-To: <1496489110-10134-1-git-send-email-jonatan.schlag@ipfire.org>

[-- Attachment #1: Type: text/plain, Size: 1318 bytes --]

We now check if the subnet, the mtu and the max-sessions valud is valid.

Signed-off-by: Jonatan Schlag <jonatan.schlag(a)ipfire.org>
---
 src/hooks/configs/pppoe-server | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

diff --git a/src/hooks/configs/pppoe-server b/src/hooks/configs/pppoe-server
index 1ef3ba9..6f95212 100644
--- a/src/hooks/configs/pppoe-server
+++ b/src/hooks/configs/pppoe-server
@@ -69,15 +69,30 @@ hook_new() {
 				;;
 			--max-sessions=*)
 				MAX_SESSIONS=$(cli_get_val ${1})
+				if ! isinteger ${MAX_SESSIONS} || ! [ ${MAX_SESSIONS} -ge 0 ]; then
+					error "Invalid value for '--max-session'. This value must be an integer greate or eqal zero."
+					exit ${EXIT_ERROR}
+				fi
 				;;
 			--mtu=*)
 				MTU=$(cli_get_val ${1})
+				if ! mtu_is_valid "ipv4" ${MTU}; then
+					error "Invalid value for '--mtu'. Cannot be larger then 9000 or smaller than 576"
+					exit ${EXIT_ERROR}
+				fi
 				;;
 			--service-name=*)
 				SERVICE_NAME=$(cli_get_val ${1})
 				;;
 			--subnet=*)
 				SUBNET=$(cli_get_val ${1})
+				if ! ipv4_net_is_valid "${SUBNET}"; then
+					error "Invalid IPv4 Subnet ${SUBNET}."
+					exit ${EXIT_ERROR}
+				fi
+				;;
+			*)
+				warning "Ignoring unknown option '${1}'"
 				;;
 		esac
 		shift
-- 
2.6.3


      parent reply	other threads:[~2017-06-03 11:25 UTC|newest]

Thread overview: 5+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-06-03 11:25 [network] [PATCH 1/4] ipv4: new function ipv4_net_is_valid Jonatan Schlag
2017-06-03 11:25 ` [network] [PATCH 2/4] ip: restructure ip_net_is_valid Jonatan Schlag
2017-06-03 11:25 ` [network] [PATCH 3/4] util: add function mtu_is_valid Jonatan Schlag
2017-06-03 13:04   ` Michael Tremer
2017-06-03 11:25 ` Jonatan Schlag [this message]

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1496489110-10134-4-git-send-email-jonatan.schlag@ipfire.org \
    --to=jonatan.schlag@ipfire.org \
    --cc=network@lists.ipfire.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox